require 'sequencer/mixin/exchange/folder'

class Sequencer
  class Unit
    module Exchange
      module Folders
        class ByIds < Sequencer::Unit::Base
          include ::Sequencer::Mixin::Exchange::Folder

          uses :ews_folder_ids
          provides :ews_folders

          def process
            state.provide(:ews_folders) do
              ews_folder_ids.collect do |folder_id|
                ews_folder.find(folder_id)
              end
            end
          end
        end
      end
    end
  end
end
